
/*----------------------------------------------------------------------
  Copyright (C) 1997, IGS Technology, Inc.

  Permission is hereby granted to use, copy and modify this software
  only for the purpose of developing IGS Technology related products.

  This software may not be distributed to any party which is not covered
  by IGS Technology Non-Disclosure Agreement (NDA).

  This software is provided "as is" without warranty of any kind,
  either expressed or implied, including but not limited to the implied
  warranties of merchantability and/or fitness for a particular purpose.

  Author: Bo
  ----------------------------------------------------------------------*/

#ifndef _IGS_H
#define _IGS_H
#include "vidcap.h"

#define SUPPORTVUNDERSCAN  1 /* 1: when TV vertical underscan, 
															* overlay is also supported
															*/

#define   PCI_FUNCTION_ID			0xB1
#define   FIND_PCI_DEVICE			0x02
#define   Vender_ID				0x10ea
#define   Device_ID				0x2000

#define XLATTABSIZE				256     /* xlat table size */
#define CVHI					255     /* clamp value hi  */
#define CVLO					0       /* clamp value lo  */

#define NTSC_GarbageLine			3				/* some garbage lines from decoder */
#define PAL_GarbageLine				4
#define NTSC_SRC_HEIGHT				480
#define PAL_SRC_HEIGHT				572 /* should be 576, but some extra 
						* gargage lines
						*/

#define WBPP					2       /* YUV 2bytes/pixels */

#define MAXMPEG1				352

#define P7111Port				0x48

#define ON					1
#define OFF					0

#define TRUE					1
#define FALSE					0

#define X_SCREEN				0
#define Y_SCREEN				1

#define LOWORD(w)	 			((unsigned short)(w))
#define HIWORD(w)	 			((unsigned short)((unsigned long)(w) >> 16))
#define LOBYTE(w)				((unsigned char)(w))
#define HIBYTE(w)				((unsigned char)((unsigned short)(w) >> 8))
#define MulDiv(x, y, z)				((long)((int) x * (int) y) / (int) z)

#define min(x, y)				((x < y) ? x : y)
#define max(x, y)				((x > y) ? x : y)
#define abs(x)					((x > 0) ? x : -x)

#define TIME1	   				100		/* 100=7.5 micro Seconds 
      						* (50 Kbits/sec, I2C max is 100 Kbits/sec
						*/
#define STOPTIME				5000	/* delay after stop cycle */
#define TimeDelay  				30
#define TimeDelay1 				10

#define IGSEXTINDEX				0x3CE
#define IGSEXTDATA				0x3CF
#define CRTINDEX				0x3D4
#define CRTDATA					0x3D5
#define SEQINDEX                                0x3c4
#define SEQDATA                                 0x3c5
#define ATTRINDEX                               0x3c0

/*IGS generic IO*/
#define ExtCrtVOver				0x11
#define ExtIRQCtrl				0x12
#define ExtFetch0				0x14
#define ExtFetch1				0x15
#define ExtBusCtrl				0x30
#define WriteBank				0x31
#define ReadBank				0x32
#define ExtBIUCtrl				0x33
#define ExtAttCtrl				0x57
#define ExtMemCtrl2				0x72
#define ExtHidenCtrl				0x73
#define ExtFIFOReg0				0x74
#define ExtFIFOReg1				0x75
#define ExtSeqMisc				0x77
#define ExtChipID0				0x91
#define ExtChipID1				0x92
#define ExtChipID2				0x93
#define ScratchReg0				0x94
#define ExtVClkData0				0xb0
#define ExtVClkData1				0xb1
#define ExtJumper1				0xb5

#define ExtChipData0				0xA1
#define ExtChipData1				0x01
#define ExtChipData2				0x00

/*IGS video IO*/
#define MEMORY_START_L				0xC0
#define MEMORY_START_M				0xC1
#define MEMORY_START_H				0xC2
#define MEMORY_PITCH_L				0xC3
#define MEMORY_PITCH_H				0xC4
#define DEST_RECT_LEFT_L			0xC5
#define DEST_RECT_LEFT_H			0xC6
#define DEST_RECT_RIGHT_L			0xC7
#define DEST_RECT_RIGHT_H			0xC8
#define DEST_RECT_TOP_L				0xC9
#define DEST_RECT_TOP_H				0xCA
#define DEST_RECT_BOTTOM_L		0xCB
#define DEST_RECT_BOTTOM_H		0xCC
#define MEMORY_OFFSET_PHASE		0xCD
#define COLOR_CMP_RED				0xCE
#define COLOR_CMP_GREEN				0xCF
#define COLOR_CMP_BLUE				0xD0
#define DDA_X_INIT_L   				0xD1
#define DDA_X_INIT_H   				0xD2
#define DDA_X_INC_L    				0xD3
#define DDA_X_INC_H    				0xD4
#define DDA_Y_INIT_L   				0xD5
#define DDA_Y_INIT_H   				0xD6
#define DDA_Y_INC_L    				0xD7
#define DDA_Y_INC_H    				0xD8
#define FIFO_TIMING_CTL_L			0xD9
#define FIFO_TIMING_CTL_H			0xDA
#define VIDEO_FORMAT   				0xDB
#define DISP_CTL_I     				0xDC
#define FIFO_CTL_I     				0xDD
#define MISC_CTL_I     				0xDE


#define VIDEO_ROM_UCB4G_HI		0xE5
#define VFAC_CTL_MODE_I				0xE8
#define VFAC_CTL_MODE_II			0xE9
#define VFAC_CTL_MODE_III			0xEA
#define CAPTURE_ADDR_L				0xEB
#define CAPTURE_ADDR_M				0xEC
#define CAPTURE_ADDR_H				0xED
#define CAPTURE_PITCH_L				0xEE
#define CAPTURE_CTL_MISC			0xEF

#define CAPTURE_TEST_CTL			0x43
#define CAPTURE_X2_CTL_I			0x49
#define CAPTURE_H_START_L			0x60
#define CAPTURE_H_START_H			0x61
#define CAPTURE_H_END_L				0x62
#define CAPTURE_H_END_H				0x63
#define CAPTURE_V_START_L			0x64
#define CAPTURE_V_START_H			0x65
#define CAPTURE_V_END_L				0x66
#define CAPTURE_V_END_H				0x67
#define CAPTURE_DDA_X_INIT_L            0x68
#define CAPTURE_DDA_X_INIT_H            0x69
#define CAPTURE_DDA_X_INC_L		0x6A
#define CAPTURE_DDA_X_INC_H		0x6B
#define CAPTURE_DDA_Y_INIT_L            0x6C
#define CAPTURE_DDA_Y_INIT_H            0x6D
#define CAPTURE_DDA_Y_INC_L		0x6E
#define CAPTURE_DDA_Y_INC_H		0x6F
#define CAPTURE_NEW_CTL_I		0x88
#define CAPTURE_NEW_CTL_II		0x89
#define CAPTURE_MODE_I				0xA4
#define CAPTURE_MODE_II				0xA5
#define CAPTURE_TV_CTL				0xAE
#define CAPTURE_BANK_CTL			0xFA

/*for 2nd Overlay Window*/
#define V_SRC_START_LO				0x40
#define V_SRC_START_MI				0x41
#define V_SRC_START_HI				0x42
#define V_SRC_STRIDE_LO				0x43
#define V_SRC_STRIDE_HI				0x44
#define V_SRC_FETCH_LO				0x4D
#define V_SRC_FETCH_HI				0x44
#define V_DST_X1_LO				0x45
#define V_DST_X1_HI				0x46
#define V_DST_X2_LO				0x47
#define V_DST_X2_HI				0x48
#define V_DST_Y1_LO				0x49
#define V_DST_Y1_HI				0x4A
#define V_DST_Y2_LO				0x4B
#define V_DST_Y2_HI				0x4C

/*for Picture in Picture*/
#define   CAP_PIP_HSTART_L     0x80
#define   CAP_PIP_HSTART_H     0x81
#define   CAP_PIP_HEND_L       0x82
#define   CAP_PIP_HEND_H       0x83
#define   CAP_PIP_VSTART_L     0x84
#define   CAP_PIP_VSTART_H     0x85
#define   CAP_PIP_VEND_L       0x86
#define   CAP_PIP_VEND_H       0x87

/*for source chroma key*/
#define CHROMA_CMP_RED_HI		0x8A
#define CHROMA_CMP_RED_LO		0x8B
#define CHROMA_CMP_GREEN_HI		0x8C
#define CHROMA_CMP_GREEN_LO		0x8D
#define CHROMA_CMP_BLUE_HI		0x8E
#define CHROMA_CMP_BLUE_LO		0x8F

#define YUV_OFS_LO			0xFC
#define YUV_OFS_HI			0xFD


/* the means by which we point to registers in the NetWinder */
extern unsigned char* pIO;

extern int wMPEG2Enable;
    
/*
 * Internal used routines
 *
 * The routines will be mostly not called by Applications but
 * are used by libary routines.
 */
int	Init_ConfigData(void);
int	writeI2C(unsigned char bVal);
int	Acknowledge(void);
int	AcknowledgeClk(void);
int	Start_Cycle(void);
int	Stop_Cycle(void);
void	ResetSeq(void);
void	Out_Video_Reg( unsigned char bIndex, unsigned char bValue );
void	Out_Video_Reg_M( unsigned char bIndex, unsigned char bValue, unsigned char bMask );
unsigned char In_Video_Reg(unsigned char bIndex);
unsigned char	ReadReg(unsigned short wReg, unsigned char bIndex);
void	ReadAcknowledge(void);
void	NotAcknowledge(void);

void	YUV422To16RGB(unsigned char  *lpRGBBuf, unsigned char  *lpYUVBuf, int nLineLen);
void	YUV422To24RGB(unsigned char  *lpRGBBuf, unsigned char  *lpYUVBuf, int nLineLen);

void	Set_Capture_Scale( unsigned short wSrcXExt, unsigned short wDstXExt, unsigned short wSrcYExt, unsigned short wDstYExt );
void	Set_Capture_addr( unsigned long dwOffAddr);

int	GetVideoFIFO(struct nw_cap_device*);
void	Change_VideoFIFO( int which );
void	IGS_SetCaptureClip(int gwVideoStandard);
int	GetCurrentScreenSize(int iScreen);
int	GetVMemSize(void);
void 	EnableCop();
void 	Set_IGS_Px_Map(int sw, int dw);
void 	wait_for_cop_ready(void);
void 	PaintWindow(int x, int y, int w, int h, unsigned long c);
void 	SrcCopy(int sx, int sy, int dx, int dy, int w, int h);

/*in philips.c */
int     DetectDecoder(struct vidcap_size*);
int  	InitPhil7110(void);
int  	InitPhil7111(void);
int  	InitSilicon(void);
int  	sendOneByte(unsigned char bAddr, unsigned char bSubaddr, unsigned char bVal);
int  	sendMoreByte(unsigned char bAddr, unsigned char bSubaddr, unsigned char *bValPtr, int iCount);
void    WaitVSync(void);
unsigned long dwGetChipID(void);

/* in igs_regs.c */
int  	IGS_InitParam(void);
void 	IGS_InitVideo(struct nw_cap_device*);
int     IGS_IsGraphics(void);
void 	IGS_VideoCleanUp(void);
void 	IGS_VideoOn(void);
void 	IGS_VideoOff(void);
void 	IGS_OverlayOn(void);
void 	IGS_OverlayOff(void);
void	IGS_SetFreezeVid (int OnOff);
void	IGS_SetFreezeVidAsync (int OnOff);
int     IGS_IsFreezeDone(void);
void 	IGS_SetCaptureFormat(int nFormat);
void 	IGS_SetOverlayFormat(unsigned char nFormat);
void 	IGS_SetOverlayWindow(struct nw_cap_device*, unsigned short wLeft, unsigned short wTop, unsigned short wRight, unsigned short wBottom);
void 	IGS_AdjustVideoWindow(struct nw_cap_device*); //int cx, int cy, int wWinWidth, int wWinHeight);
void 	IGS_SetSrcAddr(struct nw_cap_device*,
                       unsigned short wX, unsigned short wY,
                       unsigned short wPixelWidth, unsigned short wMapWidth);
int  	IGS_SetSrcWindowSize(unsigned short wWidth, unsigned short wHeight);
void 	IGS_SetAnySrcWindowSize(unsigned short wWidth, unsigned short wHeight);
void 	IGS_SetCaptureAddr(struct nw_cap_device*,int);
void 	IGS_SetXYMirror(struct nw_cap_device*, int offset);
void 	IGS_SetScale(unsigned short wSrcXExt, unsigned short wDstXExt, unsigned short wSrcYExt, unsigned short wDstYExt);
void    Set_Capture_Scale_Registers (unsigned short wSrcXExt,unsigned short wDstXExt,
                   unsigned short wSrcYExt,unsigned short wDstYExt);
void 	IGS_SetRGBKeyColor (unsigned long cref);
int     IGS_GetCurrentScreen(struct nw_cap_device*);

//2nd Video Overlay Window
void 	IGS_OverlayOn_V2(void);
void 	IGS_OverlayOff_V2(void);
void 	IGS_SetOverlayFormat_V2(unsigned char nFormat);
void 	IGS_SetOverlayWindow_V2(unsigned short wLeft, unsigned short wTop, unsigned short wRight, unsigned short wBottom);
void 	IGS_AdjustVideoWindow_V2(int cx, int cy, int wWinWidth, int wWinHeight);
void 	IGS_SetSrcAddr_V2(unsigned short wX, unsigned short wY, unsigned short wPixelWidth, unsigned short wMapWidth);
int  	IGS_SetSrcWindowSize_V2(unsigned short wWidth, unsigned short wHeight);
void 	IGS_SetScale_V2(unsigned short wSrcXExt, unsigned short wDstXExt, unsigned short wSrcYExt, unsigned short wDstYExt);
void 	IGS_SetRGBKeyColor_V2(unsigned long cref);
void 	IGS_VideoCleanUp_V2(void);

void 	IGS_SetVidStandard(int nVidStan);
void 	IGS_SetVidFormat(int nVidForm);
void 	IGS_SetVidDisplay(int nReg, int nValue);

void 	IGS_EnableIRQn(void);
void 	IGS_DisableIRQn(void);
int  	IGS_GetIRQn(void);

void 	dwSetOffScreenPtr(unsigned long dwL);
void 	dwSetOffScreenPtr_V2(unsigned long dwL);

void 	RectTransfer(char* fpDst, char* fpSrc, unsigned short wWidth, unsigned short wHeight);
int  	GetCurrentScreenSize(int iScreen);
/* in vidcap_color.c */
void 	ConvertYUVtoRGB16 (char* fpDst, char* fpSrc, unsigned short wWidth, unsigned short wHeight);
void 	ConvertYUVtoRGB24 (char* fpDst, char* fpSrc, unsigned short wWidth, unsigned short wHeight);
void	InitXlatTab (void); //YUV->RGB xlat table

#endif //_IGS_H
